Unit fMain;

{$mode objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, db, memds, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  DBCtrls, DBGrids, StdCtrls;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    btnCancel: TButton;
    btnPost: TButton;
    DataSource1: TDataSource;
    DBEdit1: TDBEdit;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    MemDataset1: TMemDataset;
    Panel1: TPanel;
    Procedure btnCancelClick(Sender: TObject);
    Procedure btnPostClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  private
    procedure GetMemoText(Sender: TField; var aText: string; DisplayText: Boolean);
  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  MemDataset1.Open;
  MemDataset1.Append;
  MemDataset1.Fields[0].AsInteger := 1;
  MemDataset1.Post;
  MemDataset1.Fields[1].OnGetText := @GetMemoText;
end;

Procedure TForm1.btnCancelClick(Sender: TObject);
Begin
  If MemDataset1.State In [dsEdit] Then
    MemDataset1.Cancel;
end;

Procedure TForm1.btnPostClick(Sender: TObject);
Begin
  If MemDataset1.State In [dsEdit] Then
    MemDataset1.Post;
end;

procedure TForm1.GetMemoText(Sender: TField; var aText: string; DisplayText: Boolean);
Begin
  aText := Sender.AsString;
End;

End.

